##// END OF EJS Templates
fix: QEMU uboot (still problems)
drtyhlpr -
r267:173f1f262ec3
parent child
Show More
@@ -1,83 +1,88
1 #
1 #
2 # Build and Setup U-Boot
2 # Build and Setup U-Boot
3 #
3 #
4
4
5 # Load utility functions
5 # Load utility functions
6 . ./functions.sh
6 . ./functions.sh
7
7
8 # Fetch and build U-Boot bootloader
8 # Fetch and build U-Boot bootloader
9 if [ "$ENABLE_UBOOT" = true ] ; then
9 if [ "$ENABLE_UBOOT" = true ] ; then
10 # Install c/c++ build environment inside the chroot
10 # Install c/c++ build environment inside the chroot
11 chroot_install_cc
11 chroot_install_cc
12
12
13 # Copy existing U-Boot sources into chroot directory
13 # Copy existing U-Boot sources into chroot directory
14 if [ -n "$UBOOTSRC_DIR" ] && [ -d "$UBOOTSRC_DIR" ] ; then
14 if [ -n "$UBOOTSRC_DIR" ] && [ -d "$UBOOTSRC_DIR" ] ; then
15 # Copy local U-Boot sources
15 # Copy local U-Boot sources
16 cp -r "${UBOOTSRC_DIR}" "${R}/tmp"
16 cp -r "${UBOOTSRC_DIR}" "${R}/tmp"
17 else
17 else
18 # Create temporary directory for U-Boot sources
18 # Create temporary directory for U-Boot sources
19 temp_dir=$(as_nobody mktemp -d)
19 temp_dir=$(as_nobody mktemp -d)
20
20
21 # Fetch U-Boot sources
21 # Fetch U-Boot sources
22 as_nobody git -C "${temp_dir}" clone "${UBOOT_URL}"
22 as_nobody git -C "${temp_dir}" clone "${UBOOT_URL}"
23
23
24 # Copy downloaded U-Boot sources
24 # Copy downloaded U-Boot sources
25 mv "${temp_dir}/u-boot" "${R}/tmp/"
25 mv "${temp_dir}/u-boot" "${R}/tmp/"
26
26
27 # Set permissions of the U-Boot sources
27 # Set permissions of the U-Boot sources
28 chown -R root:root "${R}/tmp/u-boot"
28 chown -R root:root "${R}/tmp/u-boot"
29
29
30 # Remove temporary directory for U-Boot sources
30 # Remove temporary directory for U-Boot sources
31 rm -fr "${temp_dir}"
31 rm -fr "${temp_dir}"
32 fi
32 fi
33
33
34 # Build and install U-Boot inside chroot
34 # Build and install U-Boot inside chroot
35 chroot_exec make -j${KERNEL_THREADS} -C /tmp/u-boot/ ${UBOOT_CONFIG} all
35 chroot_exec make -j${KERNEL_THREADS} -C /tmp/u-boot/ ${UBOOT_CONFIG} all
36
36
37 # Copy compiled bootloader binary and set config.txt to load it
37 # Copy compiled bootloader binary and set config.txt to load it
38 install_exec "${R}/tmp/u-boot/tools/mkimage" "${R}/usr/sbin/mkimage"
38 install_exec "${R}/tmp/u-boot/tools/mkimage" "${R}/usr/sbin/mkimage"
39 install_readonly "${R}/tmp/u-boot/u-boot.bin" "${BOOT_DIR}/u-boot.bin"
39 install_readonly "${R}/tmp/u-boot/u-boot.bin" "${BOOT_DIR}/u-boot.bin"
40 printf "\n# boot u-boot kernel\nkernel=u-boot.bin\n" >> "${BOOT_DIR}/config.txt"
40 printf "\n# boot u-boot kernel\nkernel=u-boot.bin\n" >> "${BOOT_DIR}/config.txt"
41
41
42 # Install and setup U-Boot command file
42 # Install and setup U-Boot command file
43 install_readonly files/boot/uboot.mkimage "${BOOT_DIR}/uboot.mkimage"
43 install_readonly files/boot/uboot.mkimage "${BOOT_DIR}/uboot.mkimage"
44 printf "# Set the kernel boot command line\nsetenv bootargs \"earlyprintk ${CMDLINE}\"\n\n$(cat ${BOOT_DIR}/uboot.mkimage)" > "${BOOT_DIR}/uboot.mkimage"
44 printf "# Set the kernel boot command line\nsetenv bootargs \"earlyprintk ${CMDLINE}\"\n\n$(cat ${BOOT_DIR}/uboot.mkimage)" > "${BOOT_DIR}/uboot.mkimage"
45
45
46 if [ "$ENABLE_INITRAMFS" = true ] ; then
46 if [ "$ENABLE_INITRAMFS" = true ] ; then
47 # Convert generated initramfs for U-Boot using mkimage
47 # Convert generated initramfs for U-Boot using mkimage
48 chroot_exec /usr/sbin/mkimage -A "${KERNEL_ARCH}" -T ramdisk -C none -n "initramfs-${KERNEL_VERSION}" -d "/boot/firmware/initramfs-${KERNEL_VERSION}" "/boot/firmware/initramfs-${KERNEL_VERSION}.uboot"
48 chroot_exec /usr/sbin/mkimage -A "${KERNEL_ARCH}" -T ramdisk -C none -n "initramfs-${KERNEL_VERSION}" -d "/boot/firmware/initramfs-${KERNEL_VERSION}" "/boot/firmware/initramfs-${KERNEL_VERSION}.uboot"
49
49
50 # Remove original initramfs file
50 # Remove original initramfs file
51 rm -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}"
51 rm -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}"
52
52
53 # Configure U-Boot to load generated initramfs
53 # Configure U-Boot to load generated initramfs
54 printf "# Set initramfs file\nsetenv initramfs initramfs-${KERNEL_VERSION}.uboot\n\n$(cat ${BOOT_DIR}/uboot.mkimage)" > "${BOOT_DIR}/uboot.mkimage"
54 printf "# Set initramfs file\nsetenv initramfs initramfs-${KERNEL_VERSION}.uboot\n\n$(cat ${BOOT_DIR}/uboot.mkimage)" > "${BOOT_DIR}/uboot.mkimage"
55 printf "\nbootz \${kernel_addr_r} \${ramdisk_addr_r} \${fdt_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
55 printf "\nbootz \${kernel_addr_r} \${ramdisk_addr_r} \${fdt_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
56 else # ENABLE_INITRAMFS=false
56 else # ENABLE_INITRAMFS=false
57 # Remove initramfs from U-Boot mkfile
57 # Remove initramfs from U-Boot mkfile
58 sed -i '/.*initramfs.*/d' "${BOOT_DIR}/uboot.mkimage"
58 sed -i '/.*initramfs.*/d' "${BOOT_DIR}/uboot.mkimage"
59
59
60 if [ "$BUILD_KERNEL" = false ] ; then
60 if [ "$BUILD_KERNEL" = false ] ; then
61 # Remove dtbfile from U-Boot mkfile
61 # Remove dtbfile from U-Boot mkfile
62 sed -i '/.*dtbfile.*/d' "${BOOT_DIR}/uboot.mkimage"
62 sed -i '/.*dtbfile.*/d' "${BOOT_DIR}/uboot.mkimage"
63 printf "\nbootz \${kernel_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
63 printf "\nbootz \${kernel_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
64 else
64 else
65 printf "\nbootz \${kernel_addr_r} - \${fdt_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
65 printf "\nbootz \${kernel_addr_r} - \${fdt_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
66 fi
66 fi
67 fi
67 fi
68
68
69 # Set mkfile to use the correct dtb file
69 # Set mkfile to use the correct dtb file
70 sed -i "s/^\(setenv dtbfile \).*/\1${DTB_FILE}/" "${BOOT_DIR}/uboot.mkimage"
70 sed -i "s/^\(setenv dtbfile \).*/\1${DTB_FILE}/" "${BOOT_DIR}/uboot.mkimage"
71
71
72 # Set mkfile to use the correct mach id
73 if [ "$ENABLE_QEMU" = true ] ; then
74 sed -i "s/^\(setenv machid \).*/\10x000008e0/" "${BOOT_DIR}/uboot.mkimage"
75 fi
76
72 # Set mkfile to use kernel image
77 # Set mkfile to use kernel image
73 sed -i "s/^\(fatload mmc 0:1 \${kernel_addr_r} \).*/\1${KERNEL_IMAGE}/" "${BOOT_DIR}/uboot.mkimage"
78 sed -i "s/^\(fatload mmc 0:1 \${kernel_addr_r} \).*/\1${KERNEL_IMAGE}/" "${BOOT_DIR}/uboot.mkimage"
74
79
75 # Remove all leading blank lines
80 # Remove all leading blank lines
76 sed -i "/./,\$!d" "${BOOT_DIR}/uboot.mkimage"
81 sed -i "/./,\$!d" "${BOOT_DIR}/uboot.mkimage"
77
82
78 # Generate U-Boot bootloader image
83 # Generate U-Boot bootloader image
79 chroot_exec /usr/sbin/mkimage -A "${KERNEL_ARCH}" -O linux -T script -C none -a 0x00000000 -e 0x00000000 -n "RPi${RPI_MODEL}" -d /boot/firmware/uboot.mkimage /boot/firmware/boot.scr
84 chroot_exec /usr/sbin/mkimage -A "${KERNEL_ARCH}" -O linux -T script -C none -a 0x00000000 -e 0x00000000 -n "RPi${RPI_MODEL}" -d /boot/firmware/uboot.mkimage /boot/firmware/boot.scr
80
85
81 # Remove U-Boot sources
86 # Remove U-Boot sources
82 rm -fr "${R}/tmp/u-boot"
87 rm -fr "${R}/tmp/u-boot"
83 fi
88 fi
@@ -1,754 +1,769
1 #!/bin/sh
1 #!/bin/sh
2
2
3 ########################################################################
3 ########################################################################
4 # rpi23-gen-image.sh 2015-2017
4 # rpi23-gen-image.sh 2015-2017
5 #
5 #
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 #
7 #
8 # This program is free software; you can redistribute it and/or
8 # This program is free software; you can redistribute it and/or
9 # modify it under the terms of the GNU General Public License
9 # modify it under the terms of the GNU General Public License
10 # as published by the Free Software Foundation; either version 2
10 # as published by the Free Software Foundation; either version 2
11 # of the License, or (at your option) any later version.
11 # of the License, or (at your option) any later version.
12 #
12 #
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 #
14 #
15 # Big thanks for patches and enhancements by 20+ github contributors!
15 # Big thanks for patches and enhancements by 20+ github contributors!
16 ########################################################################
16 ########################################################################
17
17
18 # Are we running as root?
18 # Are we running as root?
19 if [ "$(id -u)" -ne "0" ] ; then
19 if [ "$(id -u)" -ne "0" ] ; then
20 echo "error: this script must be executed with root privileges!"
20 echo "error: this script must be executed with root privileges!"
21 exit 1
21 exit 1
22 fi
22 fi
23
23
24 # Check if ./functions.sh script exists
24 # Check if ./functions.sh script exists
25 if [ ! -r "./functions.sh" ] ; then
25 if [ ! -r "./functions.sh" ] ; then
26 echo "error: './functions.sh' required script not found!"
26 echo "error: './functions.sh' required script not found!"
27 exit 1
27 exit 1
28 fi
28 fi
29
29
30 # Load utility functions
30 # Load utility functions
31 . ./functions.sh
31 . ./functions.sh
32
32
33 # Load parameters from configuration template file
33 # Load parameters from configuration template file
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 use_template
35 use_template
36 fi
36 fi
37
37
38 # Introduce settings
38 # Introduce settings
39 set -e
39 set -e
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 set -x
41 set -x
42
42
43 # Raspberry Pi model configuration
43 # Raspberry Pi model configuration
44 RPI_MODEL=${RPI_MODEL:=2}
44 RPI_MODEL=${RPI_MODEL:=2}
45
45
46 #bcm2708-rpi-0-w.dtb (Used for Pi 0 and PI 0W)
46 #bcm2708-rpi-0-w.dtb (Used for Pi 0 and PI 0W)
47 RPI0_DTB_FILE=${RPI0_DTB_FILE:=bcm2708-rpi-0-w.dtb}
47 RPI0_DTB_FILE=${RPI0_DTB_FILE:=bcm2708-rpi-0-w.dtb}
48 RPI0_UBOOT_CONFIG=${RPI0_UBOOT_CONFIG:=rpi_defconfig}
48 RPI0_UBOOT_CONFIG=${RPI0_UBOOT_CONFIG:=rpi_defconfig}
49
49
50 #bcm2708-rpi-b.dtb (Used for Pi 1 model A and B)
50 #bcm2708-rpi-b.dtb (Used for Pi 1 model A and B)
51 RPI1_DTB_FILE=${RPI1_DTB_FILE:=bcm2708-rpi-b.dtb}
51 RPI1_DTB_FILE=${RPI1_DTB_FILE:=bcm2708-rpi-b.dtb}
52 RPI1_UBOOT_CONFIG=${RPI1_UBOOT_CONFIG:=rpi_defconfig}
52 RPI1_UBOOT_CONFIG=${RPI1_UBOOT_CONFIG:=rpi_defconfig}
53
53
54 #bcm2708-rpi-b-plus.dtb (Used for Pi 1 model B+ and A+)
54 #bcm2708-rpi-b-plus.dtb (Used for Pi 1 model B+ and A+)
55 RPI1P_DTB_FILE=${RPI1P_DTB_FILE:=bcm2708-rpi-b-plus.dtb}
55 RPI1P_DTB_FILE=${RPI1P_DTB_FILE:=bcm2708-rpi-b-plus.dtb}
56 RPI1P_UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG:=rpi_defconfig}
56 RPI1P_UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG:=rpi_defconfig}
57
57
58 #bcm2709-rpi-2-b.dtb (Used for Pi 2 model B)
58 #bcm2709-rpi-2-b.dtb (Used for Pi 2 model B)
59 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
59 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
60 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
60 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
61
61
62 #bcm2710-rpi-3-b.dtb (Used for Pi 3 model B)
62 #bcm2710-rpi-3-b.dtb (Used for Pi 3 model B)
63 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
63 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
64 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
64 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
65
65
66 #bcm2710-rpi-3-b-plus.dtb (Used for Pi 3 model B+)
66 #bcm2710-rpi-3-b-plus.dtb (Used for Pi 3 model B+)
67 RPI3P_DTB_FILE=${RPI3P_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
67 RPI3P_DTB_FILE=${RPI3P_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
68 RPI3P_UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG:=rpi_3_32b_defconfig}
68 RPI3P_UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG:=rpi_3_32b_defconfig}
69
69
70 # Debian release
70 # Debian release
71 RELEASE=${RELEASE:=jessie}
71 RELEASE=${RELEASE:=jessie}
72 KERNEL_ARCH=${KERNEL_ARCH:=arm}
72 KERNEL_ARCH=${KERNEL_ARCH:=arm}
73 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
73 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
74 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
74 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
75 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
75 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
76 if [ "$KERNEL_ARCH" = "arm64" ] ; then
76 if [ "$KERNEL_ARCH" = "arm64" ] ; then
77 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
77 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
78 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
78 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
79 fi
79 fi
80
80
81 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
81 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
82 #RASPBERRY PI 1, PI ZERO, PI ZERO W, AND COMPUTE MODULE DEFAULT Kernel BUILD CONFIGURATION
82 #RASPBERRY PI 1, PI ZERO, PI ZERO W, AND COMPUTE MODULE DEFAULT Kernel BUILD CONFIGURATION
83 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
83 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
84 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
84 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
85 else
85 else
86 #RASPBERRY PI 2, PI 3, PI 3+, AND COMPUTE MODULE 3 DEFAULT Kernel BUILD CONFIGURATION
86 #RASPBERRY PI 2, PI 3, PI 3+, AND COMPUTE MODULE 3 DEFAULT Kernel BUILD CONFIGURATION
87 #https://www.raspberrypi.org/documentation/linux/kernel/building.md
87 #https://www.raspberrypi.org/documentation/linux/kernel/building.md
88 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
88 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
89 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
89 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
90 fi
90 fi
91
91
92 if [ "$RELEASE_ARCH" = "arm64" ] ; then
92 if [ "$RELEASE_ARCH" = "arm64" ] ; then
93 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
93 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
94 else
94 else
95 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
95 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
96 fi
96 fi
97 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
97 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
98
98
99 # URLs
99 # URLs
100 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
100 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
101 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
101 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
102 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
102 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
103 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
103 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
104 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
104 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
105 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
105 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
106
106
107 # Build directories
107 # Build directories
108 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
108 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
109 BUILDDIR="${BASEDIR}/build"
109 BUILDDIR="${BASEDIR}/build"
110
110
111 # Prepare date string for default image file name
111 # Prepare date string for default image file name
112 DATE="$(date +%Y-%m-%d)"
112 DATE="$(date +%Y-%m-%d)"
113 if [ -z "$KERNEL_BRANCH" ] ; then
113 if [ -z "$KERNEL_BRANCH" ] ; then
114 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
114 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
115 else
115 else
116 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
116 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
117 fi
117 fi
118
118
119 # Chroot directories
119 # Chroot directories
120 R="${BUILDDIR}/chroot"
120 R="${BUILDDIR}/chroot"
121 ETC_DIR="${R}/etc"
121 ETC_DIR="${R}/etc"
122 LIB_DIR="${R}/lib"
122 LIB_DIR="${R}/lib"
123 BOOT_DIR="${R}/boot/firmware"
123 BOOT_DIR="${R}/boot/firmware"
124 KERNEL_DIR="${R}/usr/src/linux"
124 KERNEL_DIR="${R}/usr/src/linux"
125 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
125 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
126
126
127 # Firmware directory: Blank if download from github
127 # Firmware directory: Blank if download from github
128 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
128 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
129
129
130 # General settings
130 # General settings
131 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
131 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
132 PASSWORD=${PASSWORD:=raspberry}
132 PASSWORD=${PASSWORD:=raspberry}
133 USER_PASSWORD=${USER_PASSWORD:=raspberry}
133 USER_PASSWORD=${USER_PASSWORD:=raspberry}
134 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
134 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
135 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
135 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
136 EXPANDROOT=${EXPANDROOT:=true}
136 EXPANDROOT=${EXPANDROOT:=true}
137
137
138 # Keyboard settings
138 # Keyboard settings
139 XKB_MODEL=${XKB_MODEL:=""}
139 XKB_MODEL=${XKB_MODEL:=""}
140 XKB_LAYOUT=${XKB_LAYOUT:=""}
140 XKB_LAYOUT=${XKB_LAYOUT:=""}
141 XKB_VARIANT=${XKB_VARIANT:=""}
141 XKB_VARIANT=${XKB_VARIANT:=""}
142 XKB_OPTIONS=${XKB_OPTIONS:=""}
142 XKB_OPTIONS=${XKB_OPTIONS:=""}
143
143
144 # Network settings (DHCP)
144 # Network settings (DHCP)
145 ENABLE_DHCP=${ENABLE_DHCP:=true}
145 ENABLE_DHCP=${ENABLE_DHCP:=true}
146
146
147 # Network settings (static)
147 # Network settings (static)
148 NET_ADDRESS=${NET_ADDRESS:=""}
148 NET_ADDRESS=${NET_ADDRESS:=""}
149 NET_GATEWAY=${NET_GATEWAY:=""}
149 NET_GATEWAY=${NET_GATEWAY:=""}
150 NET_DNS_1=${NET_DNS_1:=""}
150 NET_DNS_1=${NET_DNS_1:=""}
151 NET_DNS_2=${NET_DNS_2:=""}
151 NET_DNS_2=${NET_DNS_2:=""}
152 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
152 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
153 NET_NTP_1=${NET_NTP_1:=""}
153 NET_NTP_1=${NET_NTP_1:=""}
154 NET_NTP_2=${NET_NTP_2:=""}
154 NET_NTP_2=${NET_NTP_2:=""}
155
155
156 # APT settings
156 # APT settings
157 APT_PROXY=${APT_PROXY:=""}
157 APT_PROXY=${APT_PROXY:=""}
158 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
158 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
159
159
160 # Feature settings
160 # Feature settings
161 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
161 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
162 ENABLE_I2C=${ENABLE_I2C:=false}
162 ENABLE_I2C=${ENABLE_I2C:=false}
163 ENABLE_SPI=${ENABLE_SPI:=false}
163 ENABLE_SPI=${ENABLE_SPI:=false}
164 ENABLE_IPV6=${ENABLE_IPV6:=true}
164 ENABLE_IPV6=${ENABLE_IPV6:=true}
165 ENABLE_SSHD=${ENABLE_SSHD:=true}
165 ENABLE_SSHD=${ENABLE_SSHD:=true}
166 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
166 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
167 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
167 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
168 ENABLE_SOUND=${ENABLE_SOUND:=true}
168 ENABLE_SOUND=${ENABLE_SOUND:=true}
169 ENABLE_DBUS=${ENABLE_DBUS:=true}
169 ENABLE_DBUS=${ENABLE_DBUS:=true}
170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 ENABLE_XORG=${ENABLE_XORG:=false}
172 ENABLE_XORG=${ENABLE_XORG:=false}
173 ENABLE_WM=${ENABLE_WM:=""}
173 ENABLE_WM=${ENABLE_WM:=""}
174 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
174 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
175 ENABLE_USER=${ENABLE_USER:=true}
175 ENABLE_USER=${ENABLE_USER:=true}
176 USER_NAME=${USER_NAME:="pi"}
176 USER_NAME=${USER_NAME:="pi"}
177 ENABLE_ROOT=${ENABLE_ROOT:=false}
177 ENABLE_ROOT=${ENABLE_ROOT:=false}
178 ENABLE_QEMU=${ENABLE_QEMU:=false}
178 ENABLE_QEMU=${ENABLE_QEMU:=false}
179
179
180 # SSH settings
180 # SSH settings
181 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
181 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
182 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
182 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
183 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
183 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
184 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
184 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
185 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
185 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
186
186
187 # Advanced settings
187 # Advanced settings
188 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
188 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
189 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
189 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
190 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
190 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
191 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
191 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
192 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
192 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
193 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
193 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
194 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
194 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
195 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
195 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
196 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
196 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
197 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
197 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
198 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
198 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
199 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
199 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
200
200
201 # Kernel compilation settings
201 # Kernel compilation settings
202 BUILD_KERNEL=${BUILD_KERNEL:=false}
202 BUILD_KERNEL=${BUILD_KERNEL:=false}
203 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
203 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
204 KERNEL_THREADS=${KERNEL_THREADS:=1}
204 KERNEL_THREADS=${KERNEL_THREADS:=1}
205 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
205 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
206 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
206 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
207 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
207 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
208 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
208 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
209 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
209 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
210
210
211 if [ "$KERNEL_ARCH" = "arm64" ] ; then
211 if [ "$KERNEL_ARCH" = "arm64" ] ; then
212 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
212 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
213 else
213 else
214 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
214 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
215 fi
215 fi
216
216
217 # Kernel compilation from source directory settings
217 # Kernel compilation from source directory settings
218 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
218 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
219 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
219 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
220 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
220 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
221 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
221 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
222
222
223 # Reduce disk usage settings
223 # Reduce disk usage settings
224 REDUCE_APT=${REDUCE_APT:=true}
224 REDUCE_APT=${REDUCE_APT:=true}
225 REDUCE_DOC=${REDUCE_DOC:=true}
225 REDUCE_DOC=${REDUCE_DOC:=true}
226 REDUCE_MAN=${REDUCE_MAN:=true}
226 REDUCE_MAN=${REDUCE_MAN:=true}
227 REDUCE_VIM=${REDUCE_VIM:=false}
227 REDUCE_VIM=${REDUCE_VIM:=false}
228 REDUCE_BASH=${REDUCE_BASH:=false}
228 REDUCE_BASH=${REDUCE_BASH:=false}
229 REDUCE_HWDB=${REDUCE_HWDB:=true}
229 REDUCE_HWDB=${REDUCE_HWDB:=true}
230 REDUCE_SSHD=${REDUCE_SSHD:=true}
230 REDUCE_SSHD=${REDUCE_SSHD:=true}
231 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
231 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
232
232
233 # Encrypted filesystem settings
233 # Encrypted filesystem settings
234 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
234 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
235 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
235 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
236 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
236 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
237 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
237 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
238 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
238 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
239
239
240 # Chroot scripts directory
240 # Chroot scripts directory
241 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
241 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
242
242
243 # Packages required in the chroot build environment
243 # Packages required in the chroot build environment
244 APT_INCLUDES=${APT_INCLUDES:=""}
244 APT_INCLUDES=${APT_INCLUDES:=""}
245 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
245 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
246
246
247 # Packages required for bootstrapping
247 # Packages required for bootstrapping
248 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
248 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
249 MISSING_PACKAGES=""
249 MISSING_PACKAGES=""
250
250
251 # Packages installed for c/c++ build environment in chroot (keep empty)
251 # Packages installed for c/c++ build environment in chroot (keep empty)
252 COMPILER_PACKAGES=""
252 COMPILER_PACKAGES=""
253
253
254 set +x
254 set +x
255
255
256 # Set Raspberry Pi model specific configuration
256 # Set Raspberry Pi model specific configuration
257 if [ "$RPI_MODEL" = 0 ] ; then
257 if [ "$RPI_MODEL" = 0 ] ; then
258 DTB_FILE=${RPI2_DTB_FILE}
258 DTB_FILE=${RPI2_DTB_FILE}
259 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
259 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
260 elif [ "$RPI_MODEL" = 1 ] ; then
260 elif [ "$RPI_MODEL" = 1 ] ; then
261 DTB_FILE=${RPI2_DTB_FILE}
261 DTB_FILE=${RPI2_DTB_FILE}
262 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
262 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
263 elif [ "$RPI_MODEL" = 1P ] ; then
263 elif [ "$RPI_MODEL" = 1P ] ; then
264 DTB_FILE=${RPI2_DTB_FILE}
264 DTB_FILE=${RPI2_DTB_FILE}
265 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
265 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
266 elif [ "$RPI_MODEL" = 2 ] ; then
266 elif [ "$RPI_MODEL" = 2 ] ; then
267 DTB_FILE=${RPI2_DTB_FILE}
267 DTB_FILE=${RPI2_DTB_FILE}
268 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
268 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
269 elif [ "$RPI_MODEL" = 3 ] ; then
269 elif [ "$RPI_MODEL" = 3 ] ; then
270 DTB_FILE=${RPI3_DTB_FILE}
270 DTB_FILE=${RPI3_DTB_FILE}
271 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
271 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
272 BUILD_KERNEL=true
272 BUILD_KERNEL=true
273 elif [ "$RPI_MODEL" = 3P ] ; then
273 elif [ "$RPI_MODEL" = 3P ] ; then
274 DTB_FILE=${RPI3P_DTB_FILE}
274 DTB_FILE=${RPI3P_DTB_FILE}
275 UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG}
275 UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG}
276 BUILD_KERNEL=true
276 BUILD_KERNEL=true
277 else
277 else
278 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
278 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
279 exit 1
279 exit 1
280 fi
280 fi
281
281
282 # Check if the internal wireless interface is supported by the RPi model
282 # Check if the internal wireless interface is supported by the RPi model
283 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" = 2 ]; then
283 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" = 2 ]; then
284 echo "error: The selected Raspberry Pi model has no internal wireless interface"
284 echo "error: The selected Raspberry Pi model has no internal wireless interface"
285 exit 1
285 exit 1
286 fi
286 fi
287
287
288 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
288 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
289 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
289 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
290 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
290 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
291 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
291 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
292 exit 1
292 exit 1
293 fi
293 fi
294 fi
294 fi
295
295
296 # Build RPi2/3 Linux kernel if required by Debian release
296 # Build RPi2/3 Linux kernel if required by Debian release
297 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
297 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
298 BUILD_KERNEL=true
298 BUILD_KERNEL=true
299 fi
299 fi
300
300
301 # Add packages required for kernel cross compilation
301 # Add packages required for kernel cross compilation
302 if [ "$BUILD_KERNEL" = true ] ; then
302 if [ "$BUILD_KERNEL" = true ] ; then
303 if [ "$KERNEL_ARCH" = "arm" ] ; then
303 if [ "$KERNEL_ARCH" = "arm" ] ; then
304 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
304 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
305 else
305 else
306 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
306 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
307 fi
307 fi
308 fi
308 fi
309
309
310 # Add libncurses5 to enable kernel menuconfig
310 # Add libncurses5 to enable kernel menuconfig
311 if [ "$KERNEL_MENUCONFIG" = true ] ; then
311 if [ "$KERNEL_MENUCONFIG" = true ] ; then
312 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
312 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
313 fi
313 fi
314
314
315 # Add ccache compiler cache for (faster) kernel cross (re)compilation
315 # Add ccache compiler cache for (faster) kernel cross (re)compilation
316 if [ "$KERNEL_CCACHE" = true ] ; then
316 if [ "$KERNEL_CCACHE" = true ] ; then
317 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
317 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
318 fi
318 fi
319
319
320 # Add cryptsetup package to enable filesystem encryption
320 # Add cryptsetup package to enable filesystem encryption
321 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
321 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
322 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
322 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
323 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
323 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
324
324
325 if [ -z "$CRYPTFS_PASSWORD" ] ; then
325 if [ -z "$CRYPTFS_PASSWORD" ] ; then
326 echo "error: no password defined (CRYPTFS_PASSWORD)!"
326 echo "error: no password defined (CRYPTFS_PASSWORD)!"
327 exit 1
327 exit 1
328 fi
328 fi
329 ENABLE_INITRAMFS=true
329 ENABLE_INITRAMFS=true
330 fi
330 fi
331
331
332 # Add initramfs generation tools
332 # Add initramfs generation tools
333 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
333 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
334 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
334 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
335 fi
335 fi
336
336
337 # Add device-tree-compiler required for building the U-Boot bootloader
337 # Add device-tree-compiler required for building the U-Boot bootloader
338 if [ "$ENABLE_UBOOT" = true ] ; then
338 if [ "$ENABLE_UBOOT" = true ] ; then
339 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
339 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
340 fi
340 fi
341
341
342 # Check if root SSH (v2) public key file exists
342 # Check if root SSH (v2) public key file exists
343 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
343 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
344 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
344 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
345 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
345 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
346 exit 1
346 exit 1
347 fi
347 fi
348 fi
348 fi
349
349
350 # Check if $USER_NAME SSH (v2) public key file exists
350 # Check if $USER_NAME SSH (v2) public key file exists
351 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
351 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
352 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
352 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
353 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
353 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
354 exit 1
354 exit 1
355 fi
355 fi
356 fi
356 fi
357
357
358 # Check if all required packages are installed on the build system
358 # Check if all required packages are installed on the build system
359 for package in $REQUIRED_PACKAGES ; do
359 for package in $REQUIRED_PACKAGES ; do
360 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
360 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
361 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
361 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
362 fi
362 fi
363 done
363 done
364
364
365 # If there are missing packages ask confirmation for install, or exit
365 # If there are missing packages ask confirmation for install, or exit
366 if [ -n "$MISSING_PACKAGES" ] ; then
366 if [ -n "$MISSING_PACKAGES" ] ; then
367 echo "the following packages needed by this script are not installed:"
367 echo "the following packages needed by this script are not installed:"
368 echo "$MISSING_PACKAGES"
368 echo "$MISSING_PACKAGES"
369
369
370 echo -n "\ndo you want to install the missing packages right now? [y/n] "
370 echo -n "\ndo you want to install the missing packages right now? [y/n] "
371 read confirm
371 read confirm
372 [ "$confirm" != "y" ] && exit 1
372 [ "$confirm" != "y" ] && exit 1
373
373
374 # Make sure all missing required packages are installed
374 # Make sure all missing required packages are installed
375 apt-get -qq -y install ${MISSING_PACKAGES}
375 apt-get -qq -y install ${MISSING_PACKAGES}
376 fi
376 fi
377
377
378 # Check if ./bootstrap.d directory exists
378 # Check if ./bootstrap.d directory exists
379 if [ ! -d "./bootstrap.d/" ] ; then
379 if [ ! -d "./bootstrap.d/" ] ; then
380 echo "error: './bootstrap.d' required directory not found!"
380 echo "error: './bootstrap.d' required directory not found!"
381 exit 1
381 exit 1
382 fi
382 fi
383
383
384 # Check if ./files directory exists
384 # Check if ./files directory exists
385 if [ ! -d "./files/" ] ; then
385 if [ ! -d "./files/" ] ; then
386 echo "error: './files' required directory not found!"
386 echo "error: './files' required directory not found!"
387 exit 1
387 exit 1
388 fi
388 fi
389
389
390 # Check if specified KERNELSRC_DIR directory exists
390 # Check if specified KERNELSRC_DIR directory exists
391 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
391 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
392 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
392 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
393 exit 1
393 exit 1
394 fi
394 fi
395
395
396 # Check if specified UBOOTSRC_DIR directory exists
396 # Check if specified UBOOTSRC_DIR directory exists
397 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
397 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
398 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
398 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
399 exit 1
399 exit 1
400 fi
400 fi
401
401
402 # Check if specified FBTURBOSRC_DIR directory exists
402 # Check if specified FBTURBOSRC_DIR directory exists
403 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
403 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
404 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
404 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
405 exit 1
405 exit 1
406 fi
406 fi
407
407
408 # Check if specified CHROOT_SCRIPTS directory exists
408 # Check if specified CHROOT_SCRIPTS directory exists
409 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
409 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
410 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
410 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
411 exit 1
411 exit 1
412 fi
412 fi
413
413
414 # Check if specified device mapping already exists (will be used by cryptsetup)
414 # Check if specified device mapping already exists (will be used by cryptsetup)
415 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
415 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
416 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
416 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
417 exit 1
417 exit 1
418 fi
418 fi
419
419
420 # Don't clobber an old build
420 # Don't clobber an old build
421 if [ -e "$BUILDDIR" ] ; then
421 if [ -e "$BUILDDIR" ] ; then
422 echo "error: directory ${BUILDDIR} already exists, not proceeding"
422 echo "error: directory ${BUILDDIR} already exists, not proceeding"
423 exit 1
423 exit 1
424 fi
424 fi
425
425
426 # Setup chroot directory
426 # Setup chroot directory
427 mkdir -p "${R}"
427 mkdir -p "${R}"
428
428
429 # Check if build directory has enough of free disk space >512MB
429 # Check if build directory has enough of free disk space >512MB
430 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
430 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
431 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
431 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
432 exit 1
432 exit 1
433 fi
433 fi
434
434
435 set -x
435 set -x
436
436
437 # Call "cleanup" function on various signals and errors
437 # Call "cleanup" function on various signals and errors
438 trap cleanup 0 1 2 3 6
438 trap cleanup 0 1 2 3 6
439
439
440 # Add required packages for the minbase installation
440 # Add required packages for the minbase installation
441 if [ "$ENABLE_MINBASE" = true ] ; then
441 if [ "$ENABLE_MINBASE" = true ] ; then
442 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
442 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
443 fi
443 fi
444
444
445 # Add required locales packages
445 # Add required locales packages
446 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
446 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
447 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
447 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
448 fi
448 fi
449
449
450 # Add parted package, required to get partprobe utility
450 # Add parted package, required to get partprobe utility
451 if [ "$EXPANDROOT" = true ] ; then
451 if [ "$EXPANDROOT" = true ] ; then
452 APT_INCLUDES="${APT_INCLUDES},parted"
452 APT_INCLUDES="${APT_INCLUDES},parted"
453 fi
453 fi
454
454
455 # Add dbus package, recommended if using systemd
455 # Add dbus package, recommended if using systemd
456 if [ "$ENABLE_DBUS" = true ] ; then
456 if [ "$ENABLE_DBUS" = true ] ; then
457 APT_INCLUDES="${APT_INCLUDES},dbus"
457 APT_INCLUDES="${APT_INCLUDES},dbus"
458 fi
458 fi
459
459
460 # Add iptables IPv4/IPv6 package
460 # Add iptables IPv4/IPv6 package
461 if [ "$ENABLE_IPTABLES" = true ] ; then
461 if [ "$ENABLE_IPTABLES" = true ] ; then
462 APT_INCLUDES="${APT_INCLUDES},iptables"
462 APT_INCLUDES="${APT_INCLUDES},iptables"
463 fi
463 fi
464
464
465 # Add openssh server package
465 # Add openssh server package
466 if [ "$ENABLE_SSHD" = true ] ; then
466 if [ "$ENABLE_SSHD" = true ] ; then
467 APT_INCLUDES="${APT_INCLUDES},openssh-server"
467 APT_INCLUDES="${APT_INCLUDES},openssh-server"
468 fi
468 fi
469
469
470 # Add alsa-utils package
470 # Add alsa-utils package
471 if [ "$ENABLE_SOUND" = true ] ; then
471 if [ "$ENABLE_SOUND" = true ] ; then
472 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
472 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
473 fi
473 fi
474
474
475 # Add rng-tools package
475 # Add rng-tools package
476 if [ "$ENABLE_HWRANDOM" = true ] ; then
476 if [ "$ENABLE_HWRANDOM" = true ] ; then
477 APT_INCLUDES="${APT_INCLUDES},rng-tools"
477 APT_INCLUDES="${APT_INCLUDES},rng-tools"
478 fi
478 fi
479
479
480 # Add fbturbo video driver
480 # Add fbturbo video driver
481 if [ "$ENABLE_FBTURBO" = true ] ; then
481 if [ "$ENABLE_FBTURBO" = true ] ; then
482 # Enable xorg package dependencies
482 # Enable xorg package dependencies
483 ENABLE_XORG=true
483 ENABLE_XORG=true
484 fi
484 fi
485
485
486 # Add user defined window manager package
486 # Add user defined window manager package
487 if [ -n "$ENABLE_WM" ] ; then
487 if [ -n "$ENABLE_WM" ] ; then
488 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
488 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
489
489
490 # Enable xorg package dependencies
490 # Enable xorg package dependencies
491 ENABLE_XORG=true
491 ENABLE_XORG=true
492 fi
492 fi
493
493
494 # Add xorg package
494 # Add xorg package
495 if [ "$ENABLE_XORG" = true ] ; then
495 if [ "$ENABLE_XORG" = true ] ; then
496 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
496 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
497 fi
497 fi
498
498
499 # Replace selected packages with smaller clones
499 # Replace selected packages with smaller clones
500 if [ "$ENABLE_REDUCE" = true ] ; then
500 if [ "$ENABLE_REDUCE" = true ] ; then
501 # Add levee package instead of vim-tiny
501 # Add levee package instead of vim-tiny
502 if [ "$REDUCE_VIM" = true ] ; then
502 if [ "$REDUCE_VIM" = true ] ; then
503 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
503 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
504 fi
504 fi
505
505
506 # Add dropbear package instead of openssh-server
506 # Add dropbear package instead of openssh-server
507 if [ "$REDUCE_SSHD" = true ] ; then
507 if [ "$REDUCE_SSHD" = true ] ; then
508 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
508 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
509 fi
509 fi
510 fi
510 fi
511
511
512 if [ "$RELEASE" != "jessie" ] ; then
512 if [ "$RELEASE" != "jessie" ] ; then
513 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
513 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
514 fi
514 fi
515
515
516 # Configure kernel sources if no KERNELSRC_DIR
516 # Configure kernel sources if no KERNELSRC_DIR
517 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
517 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
518 KERNELSRC_CONFIG=true
518 KERNELSRC_CONFIG=true
519 fi
519 fi
520
520
521 # Configure reduced kernel
521 # Configure reduced kernel
522 if [ "$KERNEL_REDUCE" = true ] ; then
522 if [ "$KERNEL_REDUCE" = true ] ; then
523 KERNELSRC_CONFIG=false
523 KERNELSRC_CONFIG=false
524 fi
524 fi
525
525
526 # Configure qemu compatible kernel
526 # Configure qemu compatible kernel
527 if [ "$ENABLE_QEMU" = true ] ; then
527 if [ "$ENABLE_QEMU" = true ] ; then
528 DTB_FILE=vexpress-v2p-ca15_a7.dtb
529 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
528 KERNEL_DEFCONFIG="vexpress_defconfig"
530 KERNEL_DEFCONFIG="vexpress_defconfig"
529 if [ "$KERNEL_MENUCONFIG" = false ] ; then
531 if [ "$KERNEL_MENUCONFIG" = false ] ; then
530 KERNEL_OLDDEFCONFIG=true
532 KERNEL_OLDDEFCONFIG=true
531 fi
533 fi
532 fi
534 fi
533
535
534 # Execute bootstrap scripts
536 # Execute bootstrap scripts
535 for SCRIPT in bootstrap.d/*.sh; do
537 for SCRIPT in bootstrap.d/*.sh; do
536 head -n 3 "$SCRIPT"
538 head -n 3 "$SCRIPT"
537 . "$SCRIPT"
539 . "$SCRIPT"
538 done
540 done
539
541
540 ## Execute custom bootstrap scripts
542 ## Execute custom bootstrap scripts
541 if [ -d "custom.d" ] ; then
543 if [ -d "custom.d" ] ; then
542 for SCRIPT in custom.d/*.sh; do
544 for SCRIPT in custom.d/*.sh; do
543 . "$SCRIPT"
545 . "$SCRIPT"
544 done
546 done
545 fi
547 fi
546
548
547 # Execute custom scripts inside the chroot
549 # Execute custom scripts inside the chroot
548 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
550 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
549 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
551 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
550 chroot_exec /bin/bash -x <<'EOF'
552 chroot_exec /bin/bash -x <<'EOF'
551 for SCRIPT in /chroot_scripts/* ; do
553 for SCRIPT in /chroot_scripts/* ; do
552 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
554 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
553 $SCRIPT
555 $SCRIPT
554 fi
556 fi
555 done
557 done
556 EOF
558 EOF
557 rm -rf "${R}/chroot_scripts"
559 rm -rf "${R}/chroot_scripts"
558 fi
560 fi
559
561
560 # Remove c/c++ build environment from the chroot
562 # Remove c/c++ build environment from the chroot
561 chroot_remove_cc
563 chroot_remove_cc
562
564
563 # Remove apt-utils
565 # Remove apt-utils
564 if [ "$RELEASE" = "jessie" ] ; then
566 if [ "$RELEASE" = "jessie" ] ; then
565 chroot_exec apt-get purge -qq -y --force-yes apt-utils
567 chroot_exec apt-get purge -qq -y --force-yes apt-utils
566 fi
568 fi
567
569
568 # Generate required machine-id
570 # Generate required machine-id
569 MACHINE_ID=$(dbus-uuidgen)
571 MACHINE_ID=$(dbus-uuidgen)
570 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
572 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
571 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
573 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
572
574
573 # APT Cleanup
575 # APT Cleanup
574 chroot_exec apt-get -y clean
576 chroot_exec apt-get -y clean
575 chroot_exec apt-get -y autoclean
577 chroot_exec apt-get -y autoclean
576 chroot_exec apt-get -y autoremove
578 chroot_exec apt-get -y autoremove
577
579
578 # Unmount mounted filesystems
580 # Unmount mounted filesystems
579 umount -l "${R}/proc"
581 umount -l "${R}/proc"
580 umount -l "${R}/sys"
582 umount -l "${R}/sys"
581
583
582 # Clean up directories
584 # Clean up directories
583 rm -rf "${R}/run/*"
585 rm -rf "${R}/run/*"
584 rm -rf "${R}/tmp/*"
586 rm -rf "${R}/tmp/*"
585
587
586 # Clean up files
588 # Clean up files
587 rm -f "${ETC_DIR}/ssh/ssh_host_*"
589 rm -f "${ETC_DIR}/ssh/ssh_host_*"
588 rm -f "${ETC_DIR}/dropbear/dropbear_*"
590 rm -f "${ETC_DIR}/dropbear/dropbear_*"
589 rm -f "${ETC_DIR}/apt/sources.list.save"
591 rm -f "${ETC_DIR}/apt/sources.list.save"
590 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
592 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
591 rm -f "${ETC_DIR}/*-"
593 rm -f "${ETC_DIR}/*-"
592 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
594 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
593 rm -f "${ETC_DIR}/resolv.conf"
595 rm -f "${ETC_DIR}/resolv.conf"
594 rm -f "${R}/root/.bash_history"
596 rm -f "${R}/root/.bash_history"
595 rm -f "${R}/var/lib/urandom/random-seed"
597 rm -f "${R}/var/lib/urandom/random-seed"
596 rm -f "${R}/initrd.img"
598 rm -f "${R}/initrd.img"
597 rm -f "${R}/vmlinuz"
599 rm -f "${R}/vmlinuz"
598 rm -f "${R}${QEMU_BINARY}"
600 rm -f "${R}${QEMU_BINARY}"
599
601
600 if [ "$ENABLE_QEMU" = true ] ; then
602 if [ "$ENABLE_QEMU" = true ] ; then
601 # Setup QEMU directory
603 # Setup QEMU directory
602 mkdir "${BASEDIR}/qemu"
604 mkdir "${BASEDIR}/qemu"
603
605
604 # Copy kernel image to QEMU directory
606 # Copy kernel image to QEMU directory
605 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
607 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
606
608
607 # Copy kernel config to QEMU directory
609 # Copy kernel config to QEMU directory
608 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
610 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
609
611
610 # Copy kernel dtbs to QEMU directory
612 # Copy kernel dtbs to QEMU directory
611 for dtb in "${BOOT_DIR}/"*.dtb ; do
613 for dtb in "${BOOT_DIR}/"*.dtb ; do
612 if [ -f "${dtb}" ] ; then
614 if [ -f "${dtb}" ] ; then
613 install_readonly "${dtb}" "${BASEDIR}/qemu/"
615 install_readonly "${dtb}" "${BASEDIR}/qemu/"
614 fi
616 fi
615 done
617 done
616
618
617 # Copy kernel overlays to QEMU directory
619 # Copy kernel overlays to QEMU directory
618 if [ -d "${BOOT_DIR}/overlays" ] ; then
620 if [ -d "${BOOT_DIR}/overlays" ] ; then
619 # Setup overlays dtbs directory
621 # Setup overlays dtbs directory
620 mkdir "${BASEDIR}/qemu/overlays"
622 mkdir "${BASEDIR}/qemu/overlays"
621
623
622 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
624 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
623 if [ -f "${dtb}" ] ; then
625 if [ -f "${dtb}" ] ; then
624 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
626 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
625 fi
627 fi
626 done
628 done
627 fi
629 fi
628
630
631 # Copy u-boot files to QEMU directory
632 if [ "$ENABLE_UBOOT" = true ] ; then
633 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
634 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
635 fi
636 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
637 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
638 fi
639 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
640 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
641 fi
642 fi
643
629 # Copy initramfs to QEMU directory
644 # Copy initramfs to QEMU directory
630 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
645 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
631 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
646 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
632 fi
647 fi
633 fi
648 fi
634
649
635 # Calculate size of the chroot directory in KB
650 # Calculate size of the chroot directory in KB
636 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
651 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
637
652
638 # Calculate the amount of needed 512 Byte sectors
653 # Calculate the amount of needed 512 Byte sectors
639 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
654 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
640 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
655 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
641 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
656 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
642
657
643 # The root partition is EXT4
658 # The root partition is EXT4
644 # This means more space than the actual used space of the chroot is used.
659 # This means more space than the actual used space of the chroot is used.
645 # As overhead for journaling and reserved blocks 35% are added.
660 # As overhead for journaling and reserved blocks 35% are added.
646 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
661 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
647
662
648 # Calculate required image size in 512 Byte sectors
663 # Calculate required image size in 512 Byte sectors
649 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
664 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
650
665
651 # Prepare image file
666 # Prepare image file
652 if [ "$ENABLE_SPLITFS" = true ] ; then
667 if [ "$ENABLE_SPLITFS" = true ] ; then
653 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
668 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
654 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
669 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
655 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
670 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
656 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
671 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
657
672
658 # Write firmware/boot partition tables
673 # Write firmware/boot partition tables
659 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
674 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
660 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
675 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
661 EOM
676 EOM
662
677
663 # Write root partition table
678 # Write root partition table
664 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
679 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
665 ${TABLE_SECTORS},${ROOT_SECTORS},83
680 ${TABLE_SECTORS},${ROOT_SECTORS},83
666 EOM
681 EOM
667
682
668 # Setup temporary loop devices
683 # Setup temporary loop devices
669 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
684 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
670 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
685 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
671 else # ENABLE_SPLITFS=false
686 else # ENABLE_SPLITFS=false
672 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
687 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
673 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
688 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
674
689
675 # Write partition table
690 # Write partition table
676 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
691 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
677 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
692 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
678 ${ROOT_OFFSET},${ROOT_SECTORS},83
693 ${ROOT_OFFSET},${ROOT_SECTORS},83
679 EOM
694 EOM
680
695
681 # Setup temporary loop devices
696 # Setup temporary loop devices
682 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
697 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
683 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
698 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
684 fi
699 fi
685
700
686 if [ "$ENABLE_CRYPTFS" = true ] ; then
701 if [ "$ENABLE_CRYPTFS" = true ] ; then
687 # Create dummy ext4 fs
702 # Create dummy ext4 fs
688 mkfs.ext4 "$ROOT_LOOP"
703 mkfs.ext4 "$ROOT_LOOP"
689
704
690 # Setup password keyfile
705 # Setup password keyfile
691 touch .password
706 touch .password
692 chmod 600 .password
707 chmod 600 .password
693 echo -n ${CRYPTFS_PASSWORD} > .password
708 echo -n ${CRYPTFS_PASSWORD} > .password
694
709
695 # Initialize encrypted partition
710 # Initialize encrypted partition
696 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
711 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
697
712
698 # Open encrypted partition and setup mapping
713 # Open encrypted partition and setup mapping
699 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
714 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
700
715
701 # Secure delete password keyfile
716 # Secure delete password keyfile
702 shred -zu .password
717 shred -zu .password
703
718
704 # Update temporary loop device
719 # Update temporary loop device
705 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
720 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
706
721
707 # Wipe encrypted partition (encryption cipher is used for randomness)
722 # Wipe encrypted partition (encryption cipher is used for randomness)
708 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
723 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
709 fi
724 fi
710
725
711 # Build filesystems
726 # Build filesystems
712 mkfs.vfat "$FRMW_LOOP"
727 mkfs.vfat "$FRMW_LOOP"
713 mkfs.ext4 "$ROOT_LOOP"
728 mkfs.ext4 "$ROOT_LOOP"
714
729
715 # Mount the temporary loop devices
730 # Mount the temporary loop devices
716 mkdir -p "$BUILDDIR/mount"
731 mkdir -p "$BUILDDIR/mount"
717 mount "$ROOT_LOOP" "$BUILDDIR/mount"
732 mount "$ROOT_LOOP" "$BUILDDIR/mount"
718
733
719 mkdir -p "$BUILDDIR/mount/boot/firmware"
734 mkdir -p "$BUILDDIR/mount/boot/firmware"
720 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
735 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
721
736
722 # Copy all files from the chroot to the loop device mount point directory
737 # Copy all files from the chroot to the loop device mount point directory
723 rsync -a "${R}/" "$BUILDDIR/mount/"
738 rsync -a "${R}/" "$BUILDDIR/mount/"
724
739
725 # Unmount all temporary loop devices and mount points
740 # Unmount all temporary loop devices and mount points
726 cleanup
741 cleanup
727
742
728 # Create block map file(s) of image(s)
743 # Create block map file(s) of image(s)
729 if [ "$ENABLE_SPLITFS" = true ] ; then
744 if [ "$ENABLE_SPLITFS" = true ] ; then
730 # Create block map files for "bmaptool"
745 # Create block map files for "bmaptool"
731 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
746 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
732 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
747 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
733
748
734 # Image was successfully created
749 # Image was successfully created
735 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
750 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
736 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
751 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
737 else
752 else
738 # Create block map file for "bmaptool"
753 # Create block map file for "bmaptool"
739 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
754 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
740
755
741 # Image was successfully created
756 # Image was successfully created
742 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
757 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
743
758
744 # Create qemu qcow2 image
759 # Create qemu qcow2 image
745 if [ "$ENABLE_QEMU" = true ] ; then
760 if [ "$ENABLE_QEMU" = true ] ; then
746 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
761 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
747 QEMU_SIZE=16G
762 QEMU_SIZE=16G
748
763
749 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
764 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
750 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
765 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
751
766
752 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
767 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
753 fi
768 fi
754 fi
769 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant